=== modified file 'bzrlib/branch.py'
--- bzrlib/branch.py	2007-01-30 11:52:30 +0000
+++ bzrlib/branch.py	2007-02-09 17:16:26 +0000
@@ -1153,8 +1153,8 @@
         if history is not None:
             # mutter("cache hit for revision-history in %s", self)
             return list(history)
-        decode_utf8 = cache_utf8.decode
-        history = [decode_utf8(l.rstrip('\r\n')) for l in
+        get_cached_utf8 = cache_utf8.get_cached_utf8
+        history = [get_cached_utf8(l.rstrip('\r\n')) for l in
                 self.control_files.get('revision-history').readlines()]
         transaction.map.add_revision_history(history)
         # this call is disabled because revision_history is 

=== modified file 'bzrlib/tests/branch_implementations/test_branch.py'
--- bzrlib/tests/branch_implementations/test_branch.py	2007-01-11 17:20:25 +0000
+++ bzrlib/tests/branch_implementations/test_branch.py	2007-02-09 17:16:26 +0000
@@ -89,6 +89,17 @@
         self.assertEquals(br.revision_history(), ["rev1", "rev2", "rev3"])
         self.assertRaises(errors.ReservedId, br.append_revision, 'current:')
 
+    def test_revision_ids_are_utf8(self):
+        br = self.get_branch()
+        br.set_revision_history(['rev1', 'rev2', 'rev3'])
+        rh = br.revision_history()
+        self.assertEqual(['rev1', 'rev2', 'rev3'], rh)
+        for revision_id in rh:
+            self.assertIsInstance(revision_id, str)
+        last = br.last_revision()
+        self.assertEqual('rev3', last)
+        self.assertIsInstance(last, str)
+
     def test_fetch_revisions(self):
         """Test fetch-revision operation."""
         get_transport(self.get_url()).mkdir('b1')

